package com.example.nto.dto.entity.employee;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class EmployeeDTO {
    private long id;
    private String name;
    private String surname;
    private String patronymic;
    private String aboutMe;
    private String telephone;
    private String email;

    private long officeId;
    private String officeName;
    private String officeImageUrl;

    private String positionName; // Название должности
    private String role; // строка либо ROLE_USER, либо ROLE_ADMIN

    private String profileImageUrl;
    private boolean isBlocked;

    // Текущее состояние входа: false - visit (посещение) ещё не началось, true - visit идёт
    private boolean visitStatus;

    // Если visitStatus true, то возвращает дату и время начала посещения в формате LocalDateTime.toString(),
    // превратить обратно можно с помощью LocalDateTime.parse().
    // Если visitStatus false, то возвращает null.
    private String startVisitDateTime;
    private List<Long> visitsIdLast30Days; // Список Id посещений за последние 30 дней.

    // Возвращает количество отработанных часов за последний месяц.
    private long totalTimeVisitsLast30Days;

    // (Возможно это стоит убрать) Название офиса, в котором сейчас находится работник.
    // Если visitStatus false, возвращает null.
    private String currentOfficeName;

    // Возвращает время регистрации в формате LocalDateTime.toString(),
    // превратить обратно можно с помощью LocalDateTime.parse().
    private String createAt;
}

